function _extends() {
  _extends = Object.assign ? Object.assign.bind() : function(target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];
      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }
    return target;
  };
  return _extends.apply(this, arguments);
}
import { renderless, api } from "@xmweb-ui/vue-renderless/card/vue";
import { defineComponent, $prefix, $props, setup as _setup } from "@xmweb-ui/vue-common";
import Dropdown from "@xmweb-ui/vue-dropdown";
import DropdownMenu from "@xmweb-ui/vue-dropdown-menu";
import DropdownItem from "@xmweb-ui/vue-dropdown-item";
import Checkbox from "@xmweb-ui/vue-checkbox";
import Radio from "@xmweb-ui/vue-radio";
import { IconEllipsis } from "@xmweb-ui/vue-icon";
function normalizeComponent(scriptExports, render, staticRenderFns, functionalTemplate, injectStyles, scopeId, moduleIdentifier, shadowMode) {
  var options = typeof scriptExports === "function" ? scriptExports.options : scriptExports;
  if (render) {
    options.render = render;
    options.staticRenderFns = staticRenderFns;
    options._compiled = true;
  }
  if (functionalTemplate) {
    options.functional = true;
  }
  if (scopeId) {
    options._scopeId = "data-v-" + scopeId;
  }
  var hook;
  if (moduleIdentifier) {
    hook = function hook2(context) {
      context = context || // cached call
      this.$vnode && this.$vnode.ssrContext || // stateful
      this.parent && this.parent.$vnode && this.parent.$vnode.ssrContext;
      if (!context && typeof __VUE_SSR_CONTEXT__ !== "undefined") {
        context = __VUE_SSR_CONTEXT__;
      }
      if (injectStyles) {
        injectStyles.call(this, context);
      }
      if (context && context._registeredComponents) {
        context._registeredComponents.add(moduleIdentifier);
      }
    };
    options._ssrRegister = hook;
  } else if (injectStyles) {
    hook = shadowMode ? function() {
      injectStyles.call(this, (options.functional ? this.parent : this).$root.$options.shadowRoot);
    } : injectStyles;
  }
  if (hook) {
    if (options.functional) {
      options._injectStyles = hook;
      var originalRender = options.render;
      options.render = function renderWithStyleInjection(h, context) {
        hook.call(context);
        return originalRender(h, context);
      };
    } else {
      var existing = options.beforeCreate;
      options.beforeCreate = existing ? [].concat(existing, hook) : [hook];
    }
  }
  return {
    exports: scriptExports,
    options
  };
}

var classes = {
  "card": "overflow-hidden bg-color-bg-1 border hover:shadow",
  "size-large": "rounded-lg min-w-[31.25rem]",
  "size-medium": "rounded-lg min-w-[18.75rem]",
  "size-small": "rounded-lg min-w-[12.5rem]",
  "size-mini": "rounded min-w-[6.25rem]",
  "size-large-padding": "p-4",
  "size-medium-padding": "p-3",
  "size-small-padding": "p-3",
  "size-mini-padding": "p-2",
  "size-large-width": "w-[37.5rem]",
  "size-medium-width": "w-[25rem]",
  "size-small-width": "w-[18.75rem]",
  "size-mini-width": "w-[11.25rem]",
  "status-success": "border-color-success",
  "status-warning": "border-color-warning",
  "status-alerting": "border-color-alert",
  "status-danger": "border-color-error",
  "status-default": "border-color-border-separator",
  "title": "text-base sm:text-sm mb-3 leading-[1.375rem] text-color-text-primary mr-2",
  "checkbox": "relative left-1 pt-3 sm:pt-[0.875rem] pl-2 [&_[data-tag=xm-checkbox]]:p-0 [&_[data-tag=xm-checkbox]>span>span]:p-0 [&_[data-tag=xm-checkbox]>span:nth-child(2)]:hidden",
  "radio": "relative left-0 sm:left-3 pt-0 sm:pt-3 [&_[role=radio]_span_span]:pr-0",
  "logo": "flex mb-3 w-full justify-center items-center aspect-[2_/_1] overflow-hidden",
  "main": "text-sm sm:text-xs text-color-text-secondary overflow-y-auto",
  "footer": "p-3 border-t border-t-color-border-separator",
  "options": "w-full px-3 h-[2.625rem] flex items-center justify-around text-color-text-primary border-t border-t-color-border-separator"
};
var $constants = {
  CARD_GROUP: "CardGroup"
};
var __vue2_script = defineComponent({
  name: $prefix + "Card",
  emits: ["icon-click", "update:modelValue", "change"],
  components: {
    XmDropdown: Dropdown,
    XmDropdownMenu: DropdownMenu,
    XmDropdownItem: DropdownItem,
    XmCheckbox: Checkbox,
    XmRadio: Radio,
    IconEllipsis: IconEllipsis()
  },
  props: _extends({}, $props, {
    _constants: {
      type: Object,
      default: function _default() {
        return $constants;
      }
    },
    modelValue: {},
    src: String,
    title: String,
    cardClass: String,
    height: String,
    label: {},
    autoWidth: {
      type: Boolean,
      default: false
    },
    options: {
      type: Array,
      default: function _default2() {
        return [];
      }
    },
    iconMore: {
      type: [Object, String],
      default: function _default3() {
        return IconEllipsis();
      }
    },
    size: {
      type: String,
      default: "medium"
    },
    status: {
      type: String,
      default: "default"
    },
    checkType: {
      type: String,
      default: ""
    },
    type: {
      type: String,
      default: "text"
    },
    disabled: {
      type: Boolean,
      default: false
    }
  }),
  setup: function setup(props, context) {
    return _setup({
      props,
      context,
      renderless,
      api,
      classes,
      mono: true
    });
  }
});
var render = function render2() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("div", {
    class: _vm.m(_vm.gcls("card"), _vm.gcls("size-" + _vm.state.size), _vm.gcls("status-" + _vm.state.status), _vm.gcls(!_vm.state.autoWidth && "size-" + _vm.state.size + "-width"), _vm.state.itemChecked ? "border-color-brand" : "", _vm.state.disabled ? "bg-color-bg-2" : "", _vm.state.cardClass)
  }, [_c("div", {
    class: [_vm.state.type === "text" ? "flex" : "block"]
  }, [_vm.state.checkType === "checkbox" && _vm.state.type === "text" ? _c("div", {
    class: _vm.gcls("checkbox")
  }, [_c("xm-checkbox", {
    attrs: {
      "label": _vm.label,
      "disabled": _vm.state.disabled
    },
    model: {
      value: _vm.state.model,
      callback: function callback($$v) {
        _vm.$set(_vm.state, "model", $$v);
      },
      expression: "state.model"
    }
  })], 1) : _vm._e(), _vm.state.checkType === "radio" && _vm.state.type === "text" ? _c("div", {
    class: _vm.gcls("radio")
  }, [_c("xm-radio", {
    attrs: {
      "label": _vm.label,
      "disabled": _vm.state.disabled
    },
    model: {
      value: _vm.state.model,
      callback: function callback($$v) {
        _vm.$set(_vm.state, "model", $$v);
      },
      expression: "state.model"
    }
  }, [_c("span")])], 1) : _vm._e(), _vm.state.type === "image" ? _c("div", [_c("img", {
    staticClass: "w-full aspect-video bg-cover",
    attrs: {
      "src": _vm.src
    }
  })]) : _vm._e(), _vm.state.type === "video" ? _c("div", [_c("video", {
    staticClass: "w-full aspect-video",
    attrs: {
      "src": _vm.src,
      "controls": ""
    }
  })]) : _vm._e(), _c("div", {
    staticClass: "flex-1",
    class: _vm.gcls("size-" + _vm.state.size + "-padding")
  }, [_vm.state.type === "logo" ? _c("div", {
    class: _vm.gcls("logo")
  }, [_c("img", {
    staticClass: "bg-contain",
    attrs: {
      "src": _vm.src
    }
  })]) : _vm._e(), _vm.title || _vm.slots.title ? _c("div", {
    staticClass: "flex items-start",
    class: [_vm.state.type === "logo" && "text-center justify-center"]
  }, [_vm._t("title-left"), _vm._t("title", function() {
    return [_c("p", {
      class: _vm.gcls("title")
    }, [_vm._v(_vm._s(_vm.title))])];
  }), _vm._t("title-right")], 2) : _vm._e(), _c("div", {
    class: _vm.m(_vm.gcls("main"), _vm.state.type === "logo" ? "text-center" : ""),
    style: {
      height: _vm.state.height
    }
  }, [_vm._t("default")], 2)])]), _vm.state.effectOptions.length || _vm.slots.footer ? _c("div", {
    staticClass: "w-full"
  }, [_vm.slots.footer ? _c("div", {
    class: _vm.gcls("footer")
  }, [_vm._t("footer")], 2) : _vm._e(), _vm.state.effectOptions.length ? _c("div", {
    class: _vm.gcls("options")
  }, [_vm._l(_vm.state.effectOptions.slice(0, _vm.state.sliceNum), function(item, index) {
    return _c("div", {
      key: item.text + index,
      staticClass: "cursor-pointer",
      class: [item.disabled ? "text-color-text-disabled cursor-not-allowed" : ""],
      on: {
        "click": function click($event) {
          return _vm.handelIconClick(item, index, $event);
        }
      }
    }, [_c(item.icon, {
      tag: "component",
      staticClass: "w-4 h-4",
      class: [item.disabled ? "fill-color-icon-disabled" : ""]
    }), item.text ? _c("span", {
      staticClass: "ml-1 align-middle"
    }, [_vm._v(_vm._s(item.text))]) : _vm._e()], 1);
  }), _vm.state.effectOptions.length === _vm.state.iconNum ? _c("div", {
    staticClass: "cursor-pointer",
    class: [_vm.state.effectOptions[_vm.state.sliceNum].disabled ? "text-color-text-disabled cursor-not-allowed" : ""],
    on: {
      "click": function click($event) {
        return _vm.handelIconClick(_vm.state.effectOptions[_vm.state.sliceNum], _vm.state.sliceNum, $event);
      }
    }
  }, [_c(_vm.state.effectOptions[_vm.state.sliceNum].icon, {
    tag: "component",
    staticClass: "w-4 h-4",
    class: [_vm.state.effectOptions[_vm.state.sliceNum].disabled ? "fill-color-icon-disabled" : ""]
  }), _vm.state.effectOptions[_vm.state.sliceNum].text ? _c("span", {
    staticClass: "ml-1 align-middle"
  }, [_vm._v(_vm._s(_vm.state.effectOptions[_vm.state.sliceNum].text))]) : _vm._e()], 1) : _vm._e(), _vm.state.effectOptions.length > _vm.state.iconNum ? _c("xm-dropdown", {
    attrs: {
      "show-self-icon": ""
    },
    scopedSlots: _vm._u([{
      key: "dropdown",
      fn: function fn() {
        return [_c("xm-dropdown-menu", {
          attrs: {
            "placement": "bottom"
          }
        }, _vm._l(_vm.state.effectOptions.slice(_vm.state.sliceNum), function(item, index) {
          return _c("xm-dropdown-item", {
            key: item.text + index
          }, [_c("div", {
            class: ["px-2", item.disabled ? "text-color-text-disabled cursor-not-allowed" : ""],
            on: {
              "click": function click($event) {
                return _vm.handelIconClick(item, index + _vm.state.sliceNum, $event);
              }
            }
          }, [_c(item.icon, {
            tag: "component",
            staticClass: "w-4 h-4",
            class: [item.disabled ? "fill-color-icon-disabled" : ""]
          }), item.text ? _c("span", [_vm._v(_vm._s(item.text))]) : _vm._e()], 1)]);
        }), 1)];
      },
      proxy: true
    }], null, false, 345648546)
  }, [_c(_vm.iconMore, {
    tag: "component",
    staticClass: "w-4 h-4"
  }), _vm.state.effectOptions[0].text ? _c("span", {
    staticClass: "ml-1 text-color-text-primary"
  }, [_vm._v(_vm._s(_vm.t("ui.base.more")))]) : _vm._e()], 1) : _vm._e()], 2) : _vm._e()]) : _vm._e()]);
};
var staticRenderFns = [];
var __cssModules = {};
var __component__ = /* @__PURE__ */ normalizeComponent(__vue2_script, render, staticRenderFns, false, __vue2_injectStyles, null, null, null);
function __vue2_injectStyles(context) {
  for (var o in __cssModules) {
    this[o] = __cssModules[o];
  }
}
var Card = /* @__PURE__ */ function() {
  return __component__.exports;
}();
var version = "2.8.0";
Card.model = {
  prop: "modelValue",
  event: "update:modelValue"
};
Card.install = function(Vue) {
  Vue.component(Card.name, Card);
};
Card.version = version;
export {
  Card as default
};
